c      program main
c      integer detector
c      real azimuth,zenith
c      character*80 main_path
c      character*90 outpath
c      character*40 outfile
c      detector = 5
c      azimuth = 52.34
c      zenith = 106.94
c      main_path='../PrelimDRMdb02/compressed/'
c      call parse_drm_filename(detector,azimuth,zenith,
c     .            main_path, outpath, outfile)
c     write(*,*) 'Inputs: ',detector, azimuth, zenith
c      write(*,*) 'Outputs: ',outpath//outfile
c      detector = 10
c      azimuth = 232.64
c      zenith = 73.17
c      call parse_drm_filename(detector,azimuth,zenith,
c     .            main_path, outpath, outfile)
c      write(*,*) 'Inputs: ',detector, azimuth, zenith   
c      write(*,*) 'Outputs: ',outpath//outfile
c      detector = 13
c      azimuth = 81.011
c      zenith = 5.23
c      call parse_drm_filename(detector,azimuth,zenith,
c     .            main_path, outpath, outfile)
c      write(*,*) 'Inputs: ',detector, azimuth, zenith
c      write(*,*) 'Outputs: ',outpath//outfile
c      end     
      subroutine parse_drm_filename(detector,milliaz,
     .            millizen, leaf_ver, main_path, outpath, outfile)
C Written by Colleen A. Wilson-Hodge NASA/MSFC 2007-Jul-31     
C This routine parses file names for the drm database given a detector,
C azimuth, and zenith.
C 2007-Oct-1 Modified to conform with new naming convention for leaf drms.
C 2008-Nov-10 Modified to pass in version number for DRM leaf files.
      integer detector,testlen, milliaz, millizen
c      real azimuth, zenith   
      character*80 main_path
      character*90 outpath
      character*40 outfile
      character*7 detpathstring
      character detstring*2,azstring*8,zenstring*7, leaf_ver*3
c      leaf_ver='v10'
      if ((detector.lt.0).or.(detector.gt.13)) then
        write(*,*) 'Error-invalid detector: ',detector
	stop
      endif
C parse the detector path string
c      if (detector.lt.10) 
c     . write(detpathstring,'(A5,I1,a1)') 'NAI_0',detector,'/'	
c      if ((detector.ge.10).and.(detector.le.11))
c     .   write(detpathstring,'(A4,I2,A1)') 'NAI_',detector,'/'
c      if ((detector.ge.12).and.(detector.le.13))
c     .   write(detpathstring,'(A5,I1,A1)') 'BGO_0',detector-12,'/'    
      if (detector.lt.12) then
        write(detpathstring,'(a4,i2.2,a1)') 'NAI_',detector,'/'
      else 	
        write(detpathstring,'(a4,i2.2,a1)') 'BGO_',detector-12,'/'
      endif	
C parse the detector string      
      if (detector.lt.10) write(detstring,'(A1,I1)') 'n',detector
      if (detector.eq.10) write(detstring,'(A2)') 'na' 
      if (detector.eq.11) write(detstring,'(A2)') 'nb' 
      if ((detector.ge.12).and.(detector.le.13)) 
     .   write(detstring,'(A1,I1)') 'b',detector-12
C parse the zenith and azimuth strings
      write(zenstring,'(a1,i6.6)'),'z',millizen
      write(azstring,'(a2,i6.6)'),'az',milliaz
           
C now parse the filename
      outfile = detstring//'_'//zenstring//'_'//azstring//'_'//leaf_ver
      testlen = len_trim(outfile)
      outfile = 'glg_leaf_'//outfile(1:testlen)//'.rsp'
      testlen = len_trim(main_path)
      if (main_path(testlen:testlen).eq.'/') then
        outpath = main_path(1:testlen)//detpathstring
      else
        outpath = main_path(1:testlen)//'/'//detpathstring
      endif	
      return
      end     
     
