c      program main
c      character*130 filename
c      integer maxen,maxchan,ichan,ienerg,i,j, debug, detector,
c     . testlen
c      parameter (maxen = 200, maxchan=200)
c      real energ_lo(maxen), energ_hi(maxen), matrix(maxen,maxchan),
c     .  azimuth, zenith
c      character*80 main_path
c      character*90 outpath
c      character*40 outfile
c      filename = '../PrelimDRMdb02/compressed/NAI_05/'//
c     . 'glg_leaf_n5_z139440_az180000_v10.rsp'
c      filename = '../../testdrmout.fits'
c      azimuth = 180.000
c      zenith = 139.440
c      detector = 5
c      main_path = '../PrelimDRMdb02/compressed/'
c      call parse_drm_filename(detector,azimuth,zenith,
c     .            main_path, outpath, outfile)
c      testlen = len_trim(outpath)
c      filename = outpath(1:testlen)//outfile
c      debug=2
c     . '../PrelimDRMdb01/NAI03/GBMDRM_Z160.01_A121.56_NAI03.drm'
c      call readgbmdrm (filename, maxen,maxchan,debug,
c     .  energ_lo, energ_hi,matrix,ichan,ienerg)
c      do i=1,ienerg
c        do j = 1,ichan
c          if (matrix(i,j).gt.0.) write(*,*) i,j,matrix(i,j)
c	enddo
c      enddo
c      end
C*******************************************************************      
      subroutine readgbmdrm (filename, maxen, maxchan,debug,
     . energ_lo, energ_hi, matrix, ichan, ienerg)
C Written by Colleen A. Wilson-Hodge NASA/MSFC 2007-Jul-31
C This code reads a gbm leaf response matrix from a file.   
C Changed 2007-Oct-1: Now reads matrix stored with one row 
C for each input energy  
      implicit none
      integer status, unit, readwrite, blocksize, hdutype,
     .        maxchan, maxen, ngrp(maxen), fchan(400), nchan(400),
     .        ichan, ienerg, datacode, width, nulli,nfchan,
     .        nmat1d, chanindx,mindx,i,j,k, kchan, kindx,
     .        debug
      real energ_lo(*), energ_hi(*), matrix(maxen,maxchan),
     .  mat1d(maxchan),nulle
      character*30 comm
      logical anynull
      character*130 filename
C  The STATUS parameter must always be initialized.
      status=0
      nulle =0.
      nulli=0
C  Get an unused Logical Unit Number to use to open the FITS file.
      call ftgiou(unit,status)

C  Open the FITS file 
      readwrite=0
      call ftopen(unit,filename,readwrite,blocksize,status)
      if(debug.gt.1) write(*,*) 'Opened...',filename
C  Move to the 2nd extension (EBOUNDS)
c      call ftmahd(unit,2,hdutype,status)
c      if(debug.gt.1) write(*,*) 'Moving to 1st extension'
C Move to the 3rd extension (SPECRESP MATRIX)
      call ftmahd(unit,3,hdutype,status)
      if(debug.gt.1) 
     . write(*,*) 'Moving to 3rd extension, status = ',status
C get the number of energy channels 2007-Oct-1.      
      call ftgkyj(unit,'DETCHANS',ichan,comm,status) 
      if(debug.gt.1) write(*,*) 'ichan = ',ichan
C get the number of photon energy bins 2007-Oct-1.
      call ftgkyj(unit,'NUMEBINS',ienerg,comm,status)
      if(debug.gt.1) write(*,*) 'ienerg = ',ienerg  
C Loop over matrix rows 2007-Oct-1 All fits read staments changed to row-by-row
      do i=1, ienerg      
C read the photon energy bin edges
      if(debug.gt.1) write(*,*) 'i = ',i
        call ftgcve(unit,1,i,1,1,nulle,energ_lo(i),
     .      anynull, status)   
      if(debug.gt.1) write(*,*) 'energ_lo: ',energ_lo(i)   
        call ftgcve(unit,2,i,1,1,nulle,energ_hi(i),
     .      anynull, status)   
      if(debug.gt.1) write(*,*) 'energ_hi: ',energ_hi(i)           
C read the number of channel subsets
        call ftgcvj(unit,3,i,1,1,nulli,ngrp(i),
     .      anynull, status)  
      if(debug.gt.1) write(*,*) 'n_grp: ',ngrp(i)
      if (ngrp(i).gt.0) then
C read the start channels of the subsets
        call ftgcvj(unit,4,i,1,ngrp(i),nulli,fchan,
     .      anynull, status)
        if(debug.gt.1) write(*,*) 'fchan: ',(fchan(j),j=1,ngrp(i))	
C read the number of channels in the subsets
        call ftgcvj(unit,5,i,1,ngrp(i),nulli,nchan,
     .      anynull, status)
        if(debug.gt.1) write(*,*) 'nchan: ',(nchan(j),j=1,ngrp(i))
C read the number of non-zero matrix elements and the matrix elements
c        call ftgtcl(unit,6,i,nmat1d,width,status)
c        if(debug.gt.1) 
c     .   write(*,*) '# non-zero matrix elements: ',nmat1d
        mindx=1
        do j=1,ngrp(i)
          call ftgcve(unit,6,i,mindx,nchan(j),nulle,mat1d,
     .   anynull, status)   
        if(debug.gt.1) 
     .   write (*,*) 'matrix(',fchan(j),':',fchan(j)+nchan(j)-1,') = ',
     .   (mat1d(k), k=1,nchan(j))
C Unpack the matrix assuming ngrp = 1 for all rows.
c        chanindx=1
c        mindx=1
c      do i=1,ienerg
	  do k=0,nchan(j)-1
	    matrix(i,k+fchan(j)) = mat1d(k+1)     
	  enddo
	  mindx=mindx+nchan(j)
c	  chanindx=chanindx+1
	enddo
        endif
      enddo	
C  The FITS file must always be closed before exiting the program. 
C  Any unit numbers allocated with FTGIOU must be freed with FTFIOU.
      call ftclos(unit, status)
      call ftfiou(unit, status)

C  Check for any error, and if so print out error messages.
C  The PRINTERROR subroutine is listed near the end of this file.
      if (status .gt. 0)call printerror(status)
      end
	        
C *************************************************************************
