c      program main
c      implicit none
c      integer maxen, maxchan, ichan, ienerg, debug, i,j
c      parameter (maxen=200, maxchan=200)
c      character*130 drmfullname
c      real epx_lo(maxen,maxchan), epx_hi(maxen,maxchan)
c      debug=2
c      drmfullname='/Users/colleenwilson-hodge/gbm/drmgen/'
c     . //'sky_interpolation/PrelimDRMdb02/compressed/'
c     . //'NAI_07/glg_leaf_n7_z040463_az243505_v10.rsp'
c      call readpixeedges(drmfullname,maxchan,maxen,debug,
c     .  ichan,ienerg,epx_lo,epx_hi)
c      print*,'ienerg, ichan: ',ienerg,ichan
c      do i=1,ienerg
c        do j=1,ichan
c	  print*,'i,j,epx_lo(i,j), epx_hi(i,j): ',
c     .     i,j,epx_lo(i,j), epx_hi(i,j)
c	enddo
c      enddo	
c      end  
      subroutine readpixeedges(filename,maxchan, maxen, 
     .   debug,ichan,ienerg,epx_lo,epx_hi)
c Written by Colleen A. Wilson-Hodge 2007-Jul-31
C This code reads the energy edges (horizonal/channel) for
C a gbm leaf response matrix.
C changed 12-11-2007 because energy edge matrix is now transposed in file
      implicit none
c inputs
      character*130 filename !FITS file name
      integer maxchan, maxen ! max number of channel and photon energies 
      integer debug !increases verbosity if >1
c outputs
      real epx_lo(maxen,maxchan),epx_hi(maxen,maxchan)
      integer ichan,ienerg
c local variables
      integer status, unit, readwrite, blocksize, nulli,i,j,
     .        datacode,hdutype,width
      real nulle
      logical anynull
      character*30 comm
     
C  The STATUS parameter must always be initialized.
      status=0
      nulle =0.
      nulli=0
C  Get an unused Logical Unit Number to use to open the FITS file.
      call ftgiou(unit,status)

C  Open the FITS file 
      readwrite=0
      call ftopen(unit,filename,readwrite,blocksize,status)
      if(debug.gt.1) write(*,*) 'Opened...',filename
C  Move to the 2nd extension (EBOUNDS)
c      call ftmahd(unit,2,hdutype,status)
c      if(debug.gt.1) write(*,*) 'Moving to 1st extension'
C get the number of energy channels.      
c      call ftgkyj(unit,'NAXIS2',ichan,comm,status) 
c      if(debug.gt.1) write(*,*) 'ichan = ',ichan     
C Move to the 3rd extension (SPECRESP MATRIX)
      call ftmahd(unit,3,hdutype,status)
      if(debug.gt.1) 
     . write(*,*) 'Moving to 3rd extension, status = ',status
C get the number of energy channels 2007-Oct-1.      
      call ftgkyj(unit,'DETCHANS',ichan,comm,status) 
      if(debug.gt.1) write(*,*) 'ichan = ',ichan
C get the number of photon energy bins 2007-Oct-1.
      call ftgkyj(unit,'NUMEBINS',ienerg,comm,status)
      if(debug.gt.1) write(*,*) 'ienerg = ',ienerg  
C  Move to the 5th extension (ECOMPRESS)
      call ftmahd(unit,5,hdutype,status)
      if(debug.gt.1) write(*,*) 'Moving to 4th extension'
C read the energy channel edges for each pixel in the response matrix
      do i=1,ienerg
        do j=1,ichan
          call ftgcve(unit,2,i,j,1,nulle, epx_lo(i,j),
     .     anynull, status)
          call ftgcve(unit,3,i,j,1,nulle, epx_hi(i,j),
     .     anynull, status)
         enddo
       enddo
c       print*,(i,epx_lo(5,i),epx_hi(5,i),i=1,ichan)
C  The FITS file must always be closed before exiting the program. 
C  Any unit numbers allocated with FTGIOU must be freed with FTFIOU.
      call ftclos(unit, status)
      call ftfiou(unit, status)

C  Check for any error, and if so print out error messages.
C  The PRINTERROR subroutine is listed near the end of this file.
      if (status .gt. 0)call printerror(status)
      end
	        
C *************************************************************************
    
      
         
