C Minor bug fix 10/17/08 by Colleen Wilson-Hodge (MSFC). - added check for the case when seconds
C greater than or equal to 60.
C Another bug fix 8/24/09 by Colleen Wilson-Hodge (MSFC) - changed
C ss .ge. 60 to nint(ss) .ge. 60
!
! sec_to_date.f
!
! Created by Jason Merritt on 7/20/07.
! Copyright 2007
! 
! Use "gcc sec_to_date.f" to compile
! 
      ! Lines in fortran must start this far out

      ! The Following is Jason's original C code for this subroutine
!void jd_to_date(double AJD, double *month, double *day, double *year, double *hour, double *min, double *sec)
!{
!/* declare all variables for calculations including fractional day, which we will be using */
!	double Z; /* integer part of jd */
!	double F; /* decimal part of jd */
!	double A; /* used to calculate different ranges of jd */
!	double alpha; /* used to calculate A */
!	double B; /* used to calculate month, day, and year */
!	double C; /* used to calculate year */
!	double D; /* used to calculate month and day */
!	double E; /* used to calculate day */
!	double fracday;
!	double JD;
!
!/* calculate Z, F, and A */
!	JD = AJD + 0.5;
!	Z = bottom_out(JD);
!	F = get_decimal(JD);
!	if(Z < 2299161)
!	{	
!		A = Z;
!	}
!	else
!	{
!		alpha = bottom_out((Z - 1867216.25) / (36524.25));
!		A = (Z + 1 + alpha - bottom_out(alpha / 4));	
!	}
!/* calculate B-E */
!	B = A + 1524;
!	C = bottom_out((B - 122.1) / 365.25);
!	D = bottom_out(365.25 * C);
!	E = bottom_out((B - D) / 30.6001);
!/* calculate the day from B, D, E, and F */
!	*day = bottom_out(B - D - bottom_out(30.6001 * E) + F) ;
!/* calculate month from E */
!	if(E < 13.5)
!	{
!		*month = (E - 1);
!	}
!	if(E > 13.5)
!	{
!		*month = (E - 13);
!	}
!/* calculate year from month and C */
!	if(*month > 2.5)
!	{
!		*year = (C - 4716);
!	}
!	if(*month < 2.5)
!	{
!		*year = (C - 4715);
!	}
!/* use fracday_to_hms to get the date from the fractional day */
!	fracday = get_decimal(B - D - bottom_out(30.6001 * E) + F);
!	fracday_to_hms(fracday, hour, min, sec);
!}	
      ! Start of main function
C      PROGRAM TESTER
C      REAL *8 MJDS, JD, MJD, FRACDAY
C      INTEGER MONTH, DAY, YEAR, HH, MM, SS
CC
C      WRITE(6, *) 'input JD: '
C      READ(5, *) JD
C      
C      MJD = JD ! - 2400000.5
C      MJDS = MJD * 86400
C      
C      WRITE(6, *) 'you entered: ', JD
C      WRITE(6, *) 'in MJD this is: ', MJD
C      WRITE(6, *) '# of seconds in MJD is: ', MJDS
C      
C      FRACDAY = SEC_TO_DATE(MJDS, MONTH, DAY, YEAR, HH, MM, SS)
C      
C      WRITE(6, *) MONTH, '/', DAY, '/', YEAR
C      WRITE(6, *) 'at ', HH, ':', MM, ':', SS, ' universal time.'
CC
C      RETURN
C      END



      DOUBLE PRECISION FUNCTION SEC_TO_DATE(SECONDS, MONTH, DAY, YEAR, 
     .    HH, MM, SS)
      ! Declare all variables
      REAL *8 SECONDS, MJD, FRACDAY
      REAL *8 JD ! the actual, unmodified Julian Date
      REAL *8 OFFJD ! equal to julian date plus half a day
      REAL *8 Z ! integer part of mJD
      REAL *8 F ! decimal part of mJD
      REAL *8 A ! used in calculating different ranges of mJD
      REAL *8 ALPHA ! used in calculating A
      REAL *8 B ! used in calculating month, day, and year
      REAL *8 C ! used in calculating year
      REAL *8 D ! used in calculating month and day
      REAL *8 E ! used in calculating the day
      INTEGER MONTH, DAY, YEAR, HH, MM!, SS
      REAL*8 SS
c      print*,SECONDS
      MJD = SECONDS / 86400
      JD = MJD + 2400000.5
      OFFJD = JD + 0.5

      Z = INT(OFFJD)
c      print*,' '!z = ',z,offjd,int(offjd)
      F = (OFFJD - Z)
      IF (Z < 2299161) THEN 
        A = Z
      ELSE
        ALPHA = INT( (Z-1867216.25)/36524.25 )
        A = ( Z + 1 + ALPHA - INT(ALPHA/4) )
      ENDIF
! calculate B through E
      B = A + 1524
      C = INT((B - 122.1) / 365.25)
      D = INT(365.25 * C)
      E = INT(( B- D) / 30.6001)
! calculate the day from B, D, E, and F
      DAY = INT(B - D - INT(30.6001 * E) + F)
! calculate the month from E
      if (E < 13.5) MONTH = (E - 1)
      if (E > 13.5) MONTH = (E - 13) 
! calculate year from month and C
      if (MONTH > 2.5) YEAR = (C - 4716)
      if (MONTH < 2.5) YEAR = (C - 4715)
! calculate fractional day
      FRACDAY = ( (B - D - INT(30.6001 * E) + F) - INT(B - D - 
     .   INT(30.6001 * E) + F) )
! calculate hour min and sec
      HH = INT( FRACDAY * 24)
      MM = INT( (FRACDAY - (HH / 24.)) * 1440 )
      SS = ((FRACDAY - (HH / 24.) - (MM / 1440.) ) * 86400.d0)
      IF (nint(SS) .GE. 60.0) THEN
        MM=MM+1
	SS=SS-60.0
c 	print*,'SS = ',ss
 	IF (SS.LT.0.0) SS=0.0
c	print*,'SS = ',ss
      ENDIF 	
c      print*,'FRACDAY, HH, MM, SS: ',FRACDAY,HH,MM,SS
      SEC_TO_DATE = FRACDAY ! set the return value to fracday so this can be manipulated
                            ! outside the subroutine
      RETURN
      END
      

      ! Returns the length of a character string ignoring trailing blanks.
      FUNCTION String_Length(String)
      INTEGER         String_Length
      CHARACTER*(*)   String
      INTEGER         I, Length
      ! Start at the end of the string and search for a non-blank character.
      Length = Len(String)
      DO I = Length, 1, -1
         IF (String(I:I) .NE. ' ') THEN
            String_Length = I
            RETURN
            END IF
         String_Length = 0
         END DO
      END ! FUNCTION String_Length


      FUNCTION Upper_Case(Terminator)
      INTEGER   Terminator
      INTEGER   Upper_Case
      IF ((Terminator .GE. 97) .AND. (Terminator .LE. 122)) THEN
         Upper_Case = Terminator - 32
      ELSE
         Upper_Case = Terminator
         END IF
      END ! FUNCTION Upper_Case

